*** drivers/platform/x86/ideapad-laptop.c	2017-07-26 11:07:37.347085974 -0400
--- drivers/platform/x86/ideapad-laptop-patched.c	2017-07-26 11:12:03.936764755 -0400
***************
*** 40,46 ****
  #include <linux/device.h>
  #include <acpi/video.h>
  
! #define IDEAPAD_RFKILL_DEV_NUM	(3)
  
  #define CFG_BT_BIT	(16)
  #define CFG_3G_BIT	(17)
--- 40,46 ----
  #include <linux/device.h>
  #include <acpi/video.h>
  
! #define IDEAPAD_RFKILL_DEV_NUM	(2)
  
  #define CFG_BT_BIT	(16)
  #define CFG_3G_BIT	(17)
***************
*** 230,238 ****
  		seq_printf(s, "BL power value:\t%s\n", value ? "On" : "Off");
  	seq_printf(s, "=====================\n");
  
- 	if (!read_ec_data(priv->adev->handle, VPCCMD_R_RF, &value))
- 		seq_printf(s, "Radio status:\t%s(%lu)\n",
- 			   value ? "On" : "Off", value);
  	if (!read_ec_data(priv->adev->handle, VPCCMD_R_WIFI, &value))
  		seq_printf(s, "Wifi status:\t%s(%lu)\n",
  			   value ? "On" : "Off", value);
--- 230,235 ----
***************
*** 465,471 ****
  };
  
  static const struct ideapad_rfk_data ideapad_rfk_data[] = {
- 	{ "ideapad_wlan",    CFG_WIFI_BIT, VPCCMD_W_WIFI, RFKILL_TYPE_WLAN },
  	{ "ideapad_bluetooth", CFG_BT_BIT, VPCCMD_W_BT, RFKILL_TYPE_BLUETOOTH },
  	{ "ideapad_3g",        CFG_3G_BIT, VPCCMD_W_3G, RFKILL_TYPE_WWAN },
  };
--- 462,467 ----
***************
*** 484,501 ****
  
  static void ideapad_sync_rfk_state(struct ideapad_private *priv)
  {
- 	unsigned long hw_blocked = 0;
- 	int i;
- 
- 	if (priv->has_hw_rfkill_switch) {
- 		if (read_ec_data(priv->adev->handle, VPCCMD_R_RF, &hw_blocked))
- 			return;
- 		hw_blocked = !hw_blocked;
- 	}
- 
- 	for (i = 0; i < IDEAPAD_RFKILL_DEV_NUM; i++)
- 		if (priv->rfk[i])
- 			rfkill_set_hw_state(priv->rfk[i], hw_blocked);
  }
  
  static int ideapad_register_rfkill(struct ideapad_private *priv, int dev)
--- 480,485 ----
***************
*** 999,1004 ****
--- 983,989 ----
  			ideapad_register_rfkill(priv, i);
  
  	ideapad_sync_rfk_state(priv);
+     write_ec_cmd(priv->adev->handle, VPCCMD_W_WIFI, 1);
  	ideapad_sync_touchpad_state(priv);
  
  	if (acpi_video_get_backlight_type() == acpi_backlight_vendor) {
